// C Source File
// Created 3/2/2002; 2:15:08 PM

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

/*
Chase v1.5
Made By Philip Shirey.
Phil Software
Enjoy! :-)


Also try out more Phil Software games for the TI-89 and TI-82!
*/

//Direction Defenitions
#define DOWN	0//
#define UP		1//These define directions so I won't have to use numbers
#define RIGHT	2//
#define LEFT	3//

// Main Function
void _main(void)//Here we go!
{//  I hope you understand my coding by the help of the comments.
	randomize();//Randomize the random number generator!
	unsigned char man[]={0x7E,0x81,0xA5,0x81,0xA5,0xBD,0x81,0x7E};//Smiley Face
	unsigned char bad[]={0x18,0x10,0x3C,0x7E,0x7E,0x7E,0x7E,0x3C};//B0MB!
	unsigned short int px=50;//You
	unsigned short int py=50;
	unsigned short int bx1=80;//Chasing Bad guy1
	unsigned short int by1=80;
	unsigned short int bx2=1;//Chasing Bad guy2
	unsigned short int by2=1;
	unsigned short int by3=20;//bx3=40; Moves up and down 3
	unsigned short int bd3=LEFT;//In future versions make directions in an enum.
	unsigned short int bx4=70;//by4=80;  Move left and right 4
	unsigned short int bd4=DOWN; // Will probably add more bad guys later...
	unsigned short int bx5=90;//Random Bad guy 5
	unsigned short int by5=30;
	unsigned short int bx6=150;//Diagonal bad guy
	unsigned short int bd6=LEFT;//That's a lot of bad guys!
	unsigned short int key=0;//For key handling
	unsigned short int quitting=0;//For immediate exits...
	unsigned short int randnum=0;//For random numbers...
	unsigned short int speed=2;//Will be edited on the main screen thingy
	unsigned short int score=0;//the score
	void *kbq=kbd_queue();//for key handling
	unsigned char scorechar[4];//for displaying the score...
	unsigned speedchar[1];//For displaying the speed...
	ClrScr();//clear the screen
	DrawStr(0,40,"Push left or right to     ",A_REVERSE);//Write the strings.
	DrawStr(0,49,"change the speed.  Push   ",A_REVERSE);
	DrawStr(0,58,"enter to accept.          ",A_REVERSE);
	DrawStr(75,67,"2",A_REVERSE);
	DrawStr(60,75,"Medium",A_REVERSE);
	while (2==2){//Loop forever until broken later in this tiny loop by a break.
		key=ngetchx();//wait and get the key pressed
		if (key==KEY_LEFT){//If the key that was pressed is left
			speed--;//subtract the speed
			if (speed==0){//if the speed went too low
				speed=3;//put it at the op
			}
		}
		if (key==KEY_RIGHT){//if the key was right
			speed++;//make it bigger
			if (speed==4){//if it went too big
				speed=1;//put it at the bottom
			}
		}
		sprintf(speedchar,"%d",speed);//put in speedchar a writable version of speed
		DrawStr(75,67,speedchar,A_REVERSE);//write it
		if (speed==1){//if the speed is one
			DrawStr(60,75," Slow ",A_REVERSE);//write that the speed is one.
		}
		if (speed==2){
			DrawStr(60,75,"Medium",A_REVERSE);
		}
		if (speed==3){
			DrawStr(60,75," Fast ",A_REVERSE);
		}
		if (key==KEY_MODE||key==KEY_CLEAR){//if the user pressed mode OR clear...
			quitting=1;
			break;//quit
		}
		if (key==KEY_ENTER){
			break;
		}
	}
	speed=4-speed;//To switch the speed around.  1->3 2->2 3->1
	ClrScr();//Clear The Screen
	Sprite8(px,py,8,man,LCD_MEM,SPRT_XOR);// This function Draws/erases sprites if they are directly on eachother.
	Sprite8(bx1,by1,8,bad,LCD_MEM,SPRT_XOR);//I am doing this to display the
	Sprite8(bx2,by2,8,bad,LCD_MEM,SPRT_XOR);//sprites on the screen before
	Sprite8(40,by3,8,bad,LCD_MEM,SPRT_XOR);//I start so this routine will
	Sprite8(bx4,80,8,bad,LCD_MEM,SPRT_XOR);//draw/erase correctly.
	Sprite8(bx5,by5,8,bad,LCD_MEM,SPRT_XOR);//It erases all pixels that were already on that conflict with the pixels that are on in the picture.  Everything else is normal.
	Sprite8(bx6,(150-bx6),8,bad,LCD_MEM,SPRT_XOR);
	while (1==1&&!quitting){//While you are still alive, loop.  Break when dead.  Or, break if quitting = 1
		OSFreeTimer(USER_TIMER);//A simple timer.
		OSRegisterTimer(USER_TIMER, speed);//Start a pause for speed/20 of a second.
		while(!OSTimerExpired(USER_TIMER));//loop until the timer is over.
		if (!OSdequeue(&key,kbq)){//get the key, I think. :)
			//Strange that you don't need anything in here... actually, I don't think you even need these lines here.
		}
		if (key==KEY_UP){
			Sprite8(px,py,8,man,LCD_MEM,SPRT_XOR);//erase
			if (py>3){
				py-=5;//If you have room to move up, then go ahead
			}
			Sprite8(px,py,8,man,LCD_MEM,SPRT_XOR);//redraw
		}
		if (key==KEY_DOWN){//if the key the user pressed is down...
			Sprite8(px,py,8,man,LCD_MEM,SPRT_XOR);
			if (py<LCD_HEIGHT-12){
				py+=5;//if it has room to move down... yeah you get it...
			}
			Sprite8(px,py,8,man,LCD_MEM,SPRT_XOR);
		}
		if (key==KEY_LEFT){
			Sprite8(px,py,8,man,LCD_MEM,SPRT_XOR);
			if (px>3){//If it has room,
				px-=5;//Then px = px-5
			}
			Sprite8(px,py,8,man,LCD_MEM,SPRT_XOR);
		}
		if (key==KEY_RIGHT){
			Sprite8(px,py,8,man,LCD_MEM,SPRT_XOR);
			if (px<LCD_WIDTH-12){
				px+=5;
			}
			Sprite8(px,py,8,man,LCD_MEM,SPRT_XOR);
		}
		if (key==KEY_MODE||key==KEY_CLEAR){//    || means OR.  If the key was MODE or CLEAR...
			quitting=1;
			break;//Get out of the loop and make it so the program will just END.
		}
		//Time to let the bad guys move...
		Sprite8(bx1,by1,8,bad,LCD_MEM,SPRT_XOR);//erase bad guy one
		if (bx1<px){//If the bad guy is to the left of me
			bx1+=2;//Then move to the right.
		}
		if (bx1>px){//If the bad guy is to the right of me
			bx1-=2;//move left
		}
		if (by1>py){//If he is lower than me
			by1-=2;//move up
		}
		if (by1<py){
			by1+=2;//You should be able to figure this one out :-)
		}
		Sprite8(bx1,by1,8,bad,LCD_MEM,SPRT_XOR);//put him back on
		//That's it for bad guy 1.
		Sprite8(bx2,by2,8,bad,LCD_MEM,SPRT_XOR);//erase bad guy two
		if (bx2<px){// This is all the same, just with bad guy 2
			bx2+=1;
		}
		if (bx2>px){
			bx2-=1;
		}
		if (by2>py){
			by2-=1;
		}
		if (by2<py){
			by2+=1;
		}
		Sprite8(bx2,by2,8,bad,LCD_MEM,SPRT_XOR);//Put bad guy two back on.
		//Bad guy number 3...
		Sprite8(40,by3,8,bad,LCD_MEM,SPRT_XOR);//Take off bad guy3
		if (bd3==LEFT){// Remember?  UP is defined as 1 at the top.
			if (by3>8){//If it has room to move up
				by3-=6;
			} else {//If not...
				bd3=RIGHT;//change the direcion
			}
		} else if (bd3==RIGHT){// otherwise, if the direction is down
			if (by3<LCD_HEIGHT-15){
				by3+=6;
			} else {
				bd3=LEFT;
			}
		}
		Sprite8(40,by3,8,bad,LCD_MEM,SPRT_XOR);//Put bad guy 3 back on...
		//Bad guy number 4....
		Sprite8(bx4,80,8,bad,LCD_MEM,SPRT_XOR);//Take off 4.
		if (bd4==UP){//If its direction is left
			if (bx4>8){//Then make sure it has room
				bx4-=7;//and then move left.
			} else {//but if it doesn't have room
				bd4=DOWN;//Then change direction.
			}
		} else if (bd4==DOWN){//else, if the direction is right
			if (bx4<LCD_WIDTH-16){
				bx4+=7;
			} else {
				bd4=UP;
			}
		}
		Sprite8(bx4,80,8,bad,LCD_MEM,SPRT_XOR);//put 4 back
		randnum=random(4);//Random number stored to randnum from 0 to 3
		Sprite8(bx5,by5,8,bad,LCD_MEM,SPRT_XOR);//You should know what this does by now...
		if (randnum==UP){//if the randnum is equal to our constant UP
			if (by5>7){// and if there is room
				by5-=6;//then move up
			}
		}
		if (randnum==DOWN){//same thing with all of these different directions
			if (by5<LCD_HEIGHT-15){
				by5+=6;
			}
		}
		if (randnum==LEFT){
			if (bx5>7){
				bx5-=6;
			}
		}
		if (randnum==RIGHT){
			if (bx5<LCD_WIDTH-15){
				bx5+=6;
			}
		}
		Sprite8(bx5,by5,8,bad,LCD_MEM,SPRT_XOR);//put 5 back GRR
		//And... Sprite 6 *yawn*
		Sprite8(bx6,(150-bx6),8,bad,LCD_MEM,SPRT_XOR);//erase the 6th guy/b0mb
		if (bd6==LEFT){//if it says to to left (in this case, Left-down)
			bx6-=5;//go ahead
			if (bx6<68){//if can't go anyfarther
				bd6=RIGHT;//change direction
			}
		} else {//if the direction wasn't left at the beginning of this whole if-then-else statement...
			bx6+=5;//go the other way
			if (bx6>142){
				bd6=LEFT;//if can't go anymore, change direction BLAH
			}
		}
		Sprite8(bx6,(150-bx6),8,bad,LCD_MEM,SPRT_XOR);//put it back
		if (bx1+7>px&&bx1<px+7&&by1+7>py&&by1<py+7){//If a b0mb touches your little man, or if it is close enough :)
			break;//Close out of the while loop to end the game.
		}
		if (bx2+7>px&&bx2<px+7&&by2+7>py&&by2<py+7){//These are just for the different b0mbs, same thing, really.
			break;//break out of the while loop that goes on forever....
		}
		if (47>px&&40<px+7&&by3+7>py&&by3<py+7){
			break;
		}
		if (bx4+7>px&&bx4<px+7&&87>py&&80<py+7){
			break;
		}
		if (bx5+7>px&&bx5<px+7&&by5+7>py&&by5<py+7){
			break;
		}
		if (bx6+7>px&&bx6<px+7&&(157-bx6)>py&&(150-bx6)<py+7){
			break;
		}
		score++;//increase score by one
	}
	if (!quitting){//if mode or clear wasn't pressed...
	ngetchx();//Wait for a key to be pressed
	FontSetSys(F_8x10);//Make the font size really big
	DrawStr(35,40,"Your Score:",A_REVERSE);//display "Your Score:"
	sprintf(scorechar,"%d",score);//put score into the character array scorechar
	DrawStr(70,55,scorechar,A_REVERSE);//display score
	ngetchx();//wait for key
	}
}//End  YAY!
